﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace ClientServer.Migrations
{
    public partial class init : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "AwaitDummies",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AwaitDummies", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    Hash = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 2000, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "SolutionAssessment",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    FeedbackForStudent = table.Column<string>(maxLength: 10000, nullable: true),
                    LastAssessmentErrorMessage = table.Column<string>(maxLength: 80000, nullable: true),
                    ManualPoints = table.Column<int>(nullable: true),
                    MaxNormalTestPoints = table.Column<int>(nullable: false),
                    MaxSubmitTestPoints = table.Column<int>(nullable: false),
                    NormalTestPoints = table.Column<int>(nullable: true),
                    NoteForOtherTutors = table.Column<string>(maxLength: 10000, nullable: true),
                    SubmitTestPoints = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionAssessment", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Tags",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Description = table.Column<string>(maxLength: 2000, nullable: true),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    HtmlBackgroundColor = table.Column<string>(maxLength: 2000, nullable: true),
                    HtmlColor = table.Column<string>(maxLength: 2000, nullable: true),
                    HtmlIcon = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tags", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TestCaseSettingses",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CompileTimeoutInMs = table.Column<int>(nullable: false),
                    CompilerOptions = table.Column<string>(maxLength: 2000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    MemoryLimitInKb = table.Column<int>(nullable: false),
                    TimeoutInMs = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestCaseSettingses", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TestTypes",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    InternalName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestTypes", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "FileReferenceMarkdownAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 2000, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 2000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceMarkdownAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "FileReferenceTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 2000, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 2000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceTestAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "FileReferenceUserFileAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 2000, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 2000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceUserFileAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Langs",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LangShortcut = table.Column<string>(maxLength: 2000, nullable: true),
                    Language = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Langs", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "PLangs",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    EditorHighlightModeName = table.Column<string>(maxLength: 2000, nullable: true),
                    FileExtensionsWithDot = table.Column<string>(maxLength: 2000, nullable: true),
                    InternalName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PLangs", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "GroupRolePermissions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CanAddUserToGroup = table.Column<bool>(nullable: false),
                    CanAssessExercises = table.Column<bool>(nullable: false),
                    CanChangeExercises = table.Column<bool>(nullable: false),
                    CanChangeGroupData = table.Column<bool>(nullable: false),
                    CanChangeOtherMembersRole = table.Column<bool>(nullable: false),
                    CanCreateExercises = table.Column<bool>(nullable: false),
                    CanDeleteExercises = table.Column<bool>(nullable: false),
                    CanLockExercisesPermanently = table.Column<bool>(nullable: false),
                    CanManageExerciseReleases = table.Column<bool>(nullable: false),
                    CanRemoveMemberFromGroup = table.Column<bool>(nullable: false),
                    CanSeeExercisesFromOthersInGroup = table.Column<bool>(nullable: false),
                    CanSeeOtherMembers = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GroupRolePermissions", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "CodeEditorSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    FontSize = table.Column<int>(nullable: false),
                    HighlightCurrentLine = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    ShowInvisibles = table.Column<bool>(nullable: false),
                    ShowLineIndentions = table.Column<bool>(nullable: false),
                    ShowLineNumbers = table.Column<bool>(nullable: false),
                    TabSize = table.Column<int>(nullable: false),
                    Theme = table.Column<string>(maxLength: 2000, nullable: true),
                    UseWrapping = table.Column<bool>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CodeEditorSettings", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "SystemRolePermissions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CanChangeOtherUsersSystemRole = table.Column<bool>(nullable: false),
                    CanChangeRoles = table.Column<bool>(nullable: false),
                    CanChangeSystemSettings = table.Column<bool>(nullable: false),
                    CanChangeUserData = table.Column<bool>(nullable: false),
                    CanCreateGroups = table.Column<bool>(nullable: false),
                    CanCreateRoles = table.Column<bool>(nullable: false),
                    CanDeleteActivatedUsers = table.Column<bool>(nullable: false),
                    CanDeleteGroups = table.Column<bool>(nullable: false),
                    CanDeleteRoles = table.Column<bool>(nullable: false),
                    CanManageNewUsers = table.Column<bool>(nullable: false),
                    CanManageTags = table.Column<bool>(nullable: false),
                    CanViewDashboard = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemRolePermissions", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "UserGroups",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    Email = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserGroups", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "GroupRoles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    GroupRolePermissionId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GroupRoles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_GroupRoles_GroupRolePermissions_GroupRolePermissionId",
                        column: x => x.GroupRolePermissionId,
                        principalTable: "GroupRolePermissions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SystemRoles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    Email = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    SystemRolePermissionId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemRoles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SystemRoles_SystemRolePermissions_SystemRolePermissionId",
                        column: x => x.SystemRolePermissionId,
                        principalTable: "SystemRolePermissions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SystemSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CurrentServerMessage = table.Column<string>(maxLength: 10000, nullable: true),
                    CustomProjectTestCompileTimeoutInMs = table.Column<int>(nullable: false),
                    CustomProjectTestMaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    CustomProjectTestMemoryLimitInKb = table.Column<int>(nullable: false),
                    CustomProjectTestTimeoutInMs = table.Column<int>(nullable: false),
                    DefaultGroupCreatorGroupRoleId = table.Column<int>(nullable: false),
                    DefaultGroupRoleId = table.Column<int>(nullable: false),
                    DefaultUserGroupId = table.Column<int>(nullable: false),
                    JustRunProgramCompileTimeoutInMs = table.Column<int>(nullable: false),
                    JustRunProgramMaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    JustRunProgramMemoryLimitInKb = table.Column<int>(nullable: false),
                    JustRunProgramTimeoutInMs = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxCustomProjectsPerUser = table.Column<int>(nullable: false),
                    MaxCustomTestsPerParticipation = table.Column<int>(nullable: false),
                    MaxNumberOfTestsWithOneRequest = table.Column<int>(nullable: false),
                    MaxNumberOfTestsWithOneRequestSubmitTestServer = table.Column<int>(nullable: false),
                    SubmitTestServerTimeoutInMs = table.Column<int>(nullable: false),
                    SubmitTestServerUrl = table.Column<string>(maxLength: 2000, nullable: true),
                    TestServerConfigUiUrl = table.Column<string>(maxLength: 2000, nullable: true),
                    TestServerStatsUrl = table.Column<string>(maxLength: 2000, nullable: true),
                    TestServerTimeoutInMs = table.Column<int>(nullable: false),
                    TestServerUrl = table.Column<string>(maxLength: 2000, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemSettings", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                        column: x => x.DefaultGroupCreatorGroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                        column: x => x.DefaultGroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                        column: x => x.DefaultUserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "Users",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Email = table.Column<string>(maxLength: 2000, nullable: true),
                    FirstName = table.Column<string>(maxLength: 2000, nullable: true),
                    IsActivated = table.Column<bool>(nullable: false),
                    LastLoginAt = table.Column<DateTime>(nullable: false),
                    LastName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Password = table.Column<string>(maxLength: 2000, nullable: true),
                    SystemRoleId = table.Column<int>(nullable: true),
                    Token = table.Column<string>(maxLength: 2000, nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Users", x => x.Id);
                    table.UniqueConstraint("Unique_Token", x => x.Token);
                    table.ForeignKey(
                        name: "FK_Users_SystemRoles_SystemRoleId",
                        column: x => x.SystemRoleId,
                        principalTable: "SystemRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjects",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastEditorPLangId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    UserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjects", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjects_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Exercises",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CanUserCreateCustomTests = table.Column<bool>(nullable: false),
                    CanUserCreateFiles = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    IsOnlyVisibleToOwner = table.Column<bool>(nullable: false),
                    IsPermanentlyLocked = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Note = table.Column<string>(maxLength: 10000, nullable: true),
                    ShortDescription = table.Column<string>(maxLength: 2000, nullable: true),
                    UserGroupId = table.Column<int>(nullable: false),
                    UserId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Exercises", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Exercises_UserGroups_UserGroupId",
                        column: x => x.UserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Exercises_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "AuthTokens",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CsrfToken = table.Column<string>(maxLength: 2000, nullable: true),
                    ExpirationDateTime = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    RandomSecret = table.Column<string>(maxLength: 2000, nullable: true),
                    UserAuthToken = table.Column<string>(maxLength: 2000, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AuthTokens", x => x.UserId);
                    table.ForeignKey(
                        name: "FK_AuthTokens_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "ExternalUsers",
                columns: table => new
                {
                    ExternalId = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Email = table.Column<string>(maxLength: 2000, nullable: true),
                    FirstName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    NeedToRefreshData = table.Column<bool>(nullable: false),
                    Token = table.Column<string>(maxLength: 2000, nullable: false),
                    UserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExternalUsers", x => x.ExternalId);
                    table.UniqueConstraint("Unique_ExternalToken", x => x.Token);
                    table.ForeignKey(
                        name: "FK_ExternalUsers_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "UserSettingses",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CodeEditorSettingsId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LangId = table.Column<int>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Theme = table.Column<string>(maxLength: 2000, nullable: true),
                    UserId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserSettingses", x => x.Id);
                    table.ForeignKey(
                        name: "FK_UserSettingses_CodeEditorSettings_CodeEditorSettingsId",
                        column: x => x.CodeEditorSettingsId,
                        principalTable: "CodeEditorSettings",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_UserSettingses_Langs_LangId",
                        column: x => x.LangId,
                        principalTable: "Langs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_UserSettingses_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "UserWithUserGroups",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    UserGroupId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    GroupRoleId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserWithUserGroups", x => new { x.UserId, x.UserGroupId });
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                        column: x => x.GroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_UserGroups_UserGroupId",
                        column: x => x.UserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectDescriptions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 50000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectDescriptions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptions_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTests",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 80000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestSettingsId = table.Column<int>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false),
                    Weight = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTests", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_TestCaseSettingses_TestSettingsId",
                        column: x => x.TestSettingsId,
                        principalTable: "TestCaseSettingses",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTests_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseDescriptions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 50000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseDescriptions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptions_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "MetaDatas",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    ExerciseId1 = table.Column<int>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_MetaDatas", x => x.Id);
                    table.ForeignKey(
                        name: "FK_MetaDatas_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_MetaDatas_Exercises_ExerciseId1",
                        column: x => x.ExerciseId1,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseReleases",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    AutomaticEndAt = table.Column<DateTime>(nullable: true),
                    AutomaticStartAt = table.Column<DateTime>(nullable: true),
                    AvailableWorkingTimeInMinutes = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    GeneratedCode = table.Column<string>(maxLength: 2000, nullable: false),
                    HadAutomaticAssessmentErrors = table.Column<bool>(nullable: false),
                    HasAutomaticAssessmentFinished = table.Column<bool>(nullable: false),
                    HasAutomaticAssessmentStarted = table.Column<bool>(nullable: false),
                    HasLimitedWorkingTime = table.Column<bool>(nullable: false),
                    HideExerciseLeaveActions = table.Column<bool>(nullable: false),
                    HideInOverviews = table.Column<bool>(nullable: false),
                    HidePrintOptions = table.Column<bool>(nullable: false),
                    HideSiteHeaderBar = table.Column<bool>(nullable: false),
                    IsReleased = table.Column<bool>(nullable: false),
                    IsVisibleToAllAfterRelease = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxManualPoint = table.Column<int>(nullable: true),
                    Note = table.Column<string>(maxLength: 10000, nullable: true),
                    PLangId = table.Column<int>(nullable: false),
                    ReleaseDurationType = table.Column<int>(nullable: false),
                    ReleaseStartType = table.Column<int>(nullable: false),
                    ReleasedAt = table.Column<DateTime>(nullable: true),
                    RunAlsoNormalTests = table.Column<bool>(nullable: false),
                    ShouldAutomaticAssessSubmissions = table.Column<bool>(nullable: false),
                    ShouldClearClipboard = table.Column<bool>(nullable: false),
                    ShowAdditionalLogButton = table.Column<bool>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseReleases", x => x.Id);
                    table.UniqueConstraint("Unique_GeneratedCode", x => x.GeneratedCode);
                    table.ForeignKey(
                        name: "FK_ExerciseReleases_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseReleases_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "DefaultCustomTestSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CompileTimeoutInMs = table.Column<int>(nullable: false),
                    CompilerOptions = table.Column<string>(maxLength: 2000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    MemoryLimitInKb = table.Column<int>(nullable: false),
                    TimeoutInMs = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DefaultCustomTestSettings", x => x.Id);
                    table.ForeignKey(
                        name: "FK_DefaultCustomTestSettings_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Tests",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 80000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    ExerciseId = table.Column<int>(nullable: false),
                    IsSubmitTest = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestSettingsId = table.Column<int>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false),
                    Weight = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tests", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Tests_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Tests_TestCaseSettingses_TestSettingsId",
                        column: x => x.TestSettingsId,
                        principalTable: "TestCaseSettingses",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Tests_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectDescriptionWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomProjectDescriptionId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectDescriptionWithFileAsAssetReferences", x => new { x.CustomProjectDescriptionId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptionWithFileAsAssetReferences_CustomProjectDescriptions_CustomProjectDescriptionId",
                        column: x => x.CustomProjectDescriptionId,
                        principalTable: "CustomProjectDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectDescriptionWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestWithFileAsAssetReferences", x => new { x.CustomProjectTestId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithFileAsAssetReferences_CustomProjectTests_CustomProjectTestId",
                        column: x => x.CustomProjectTestId,
                        principalTable: "CustomProjectTests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseDescriptionWithFileAsAssetReferences",
                columns: table => new
                {
                    ExerciseDescriptionId = table.Column<int>(nullable: false),
                    FileReferenceMarkdownAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseDescriptionWithFileAsAssetReferences", x => new { x.ExerciseDescriptionId, x.FileReferenceMarkdownAssetId });
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptionWithFileAsAssetReferences_ExerciseDescriptions_ExerciseDescriptionId",
                        column: x => x.ExerciseDescriptionId,
                        principalTable: "ExerciseDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptionWithFileAsAssetReferences_FileReferenceMarkdownAssets_FileReferenceMarkdownAssetId",
                        column: x => x.FileReferenceMarkdownAssetId,
                        principalTable: "FileReferenceMarkdownAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TagWithMetaDatas",
                columns: table => new
                {
                    TagId = table.Column<int>(nullable: false),
                    MetaDataId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TagWithMetaDatas", x => new { x.TagId, x.MetaDataId });
                    table.ForeignKey(
                        name: "FK_TagWithMetaDatas_MetaDatas_MetaDataId",
                        column: x => x.MetaDataId,
                        principalTable: "MetaDatas",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TagWithMetaDatas_Tags_TagId",
                        column: x => x.TagId,
                        principalTable: "Tags",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseReleaseWithUserAsParticipations",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastEditedPLangId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    LockSolutionsFlag = table.Column<bool>(nullable: false),
                    ShouldNotCount = table.Column<bool>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseReleaseWithUserAsParticipations", x => new { x.UserId, x.ExerciseReleaseId });
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_ExerciseReleases_ExerciseReleaseId",
                        column: x => x.ExerciseReleaseId,
                        principalTable: "ExerciseReleases",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                        column: x => x.LastEditedPLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestWithFileAsAssetReferences",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    FileReferenceTestAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithFileAsAssetReferences", x => new { x.TestId, x.FileReferenceTestAssetId });
                    table.ForeignKey(
                        name: "FK_TestWithFileAsAssetReferences_FileReferenceTestAssets_FileReferenceTestAssetId",
                        column: x => x.FileReferenceTestAssetId,
                        principalTable: "FileReferenceTestAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestWithFileAsAssetReferences_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTest",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 80000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(maxLength: 2000, nullable: true),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false),
                    UserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTest", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomTest_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTest_ExerciseReleaseWithUserAsParticipations_UserId_ExerciseReleaseId",
                        columns: x => new { x.UserId, x.ExerciseReleaseId },
                        principalTable: "ExerciseReleaseWithUserAsParticipations",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithFileAsAssetReferences",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    FileReferenceUserFileAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithFileAsAssetReferences", x => new { x.CustomTestId, x.FileReferenceUserFileAssetId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithFileAsAssetReferences_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithFileAsAssetReferences_FileReferenceUserFileAssets_FileReferenceUserFileAssetId",
                        column: x => x.FileReferenceUserFileAssetId,
                        principalTable: "FileReferenceUserFileAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectSolutions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    PLangId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectSolutions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutions_CustomProjects_CustomProjectId",
                        column: x => x.CustomProjectId,
                        principalTable: "CustomProjects",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutions_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectSolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 70000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectSolutionId = table.Column<int>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(maxLength: 2000, nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectSolutionFiles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomProjectSolutionFiles_CustomProjectSolutions_CustomProjectSolutionId",
                        column: x => x.CustomProjectSolutionId,
                        principalTable: "CustomProjectSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomProjectTestWithSolutionAsTestResults",
                columns: table => new
                {
                    CustomProjectSolutionId = table.Column<int>(nullable: false),
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    CompileTimeoutInMsUsed = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(maxLength: 160100, nullable: true),
                    RunnerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TestResultCode = table.Column<int>(nullable: true),
                    TestServerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TimeForCompiling = table.Column<int>(nullable: true),
                    TimeForUserProgram = table.Column<int>(nullable: true),
                    TimeoutInMsUsed = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestWithSolutionAsTestResults", x => new { x.CustomProjectSolutionId, x.CustomProjectTestId });
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithSolutionAsTestResults_CustomProjectSolutions_CustomProjectSolutionId",
                        column: x => x.CustomProjectSolutionId,
                        principalTable: "CustomProjectSolutions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomProjectTestWithSolutionAsTestResults_CustomProjectTests_CustomProjectTestId",
                        column: x => x.CustomProjectTestId,
                        principalTable: "CustomProjectTests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "AfterSolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    Content = table.Column<string>(maxLength: 70000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(maxLength: 2000, nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TemplateFileId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AfterSolutionFiles", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithAfterSolutionAsTestResults",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    CompileTimeoutInMsUsed = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(maxLength: 160100, nullable: true),
                    RunnerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TestResultCode = table.Column<int>(nullable: true),
                    TestServerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TimeForCompiling = table.Column<int>(nullable: true),
                    TimeForUserProgram = table.Column<int>(nullable: true),
                    TimeoutInMsUsed = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithAfterSolutionAsTestResults", x => new { x.CustomTestId, x.AfterSolutionId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithAfterSolutionAsTestResults_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestWithAfterSolutionAsTestResults",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    AfterSolutionId = table.Column<int>(nullable: false),
                    CompileTimeoutInMsUsed = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(maxLength: 160100, nullable: true),
                    RunnerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TestResultCode = table.Column<int>(nullable: true),
                    TestServerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TimeForCompiling = table.Column<int>(nullable: true),
                    TimeForUserProgram = table.Column<int>(nullable: true),
                    TimeoutInMsUsed = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithAfterSolutionAsTestResults", x => new { x.TestId, x.AfterSolutionId });
                    table.ForeignKey(
                        name: "FK_TestWithAfterSolutionAsTestResults_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "AfterSolutions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AfterSolutions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_AfterSolutions_AfterSolutionFiles_MainFileId",
                        column: x => x.MainFileId,
                        principalTable: "AfterSolutionFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "TemplateFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CodeTemplateId = table.Column<int>(nullable: false),
                    Content = table.Column<string>(maxLength: 70000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(maxLength: 2000, nullable: true),
                    IsContentVisibleForUser = table.Column<bool>(nullable: false),
                    IsEditableByUser = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TemplateFiles", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Templates",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    PLangId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Templates", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Templates_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Templates_TemplateFiles_MainFileId",
                        column: x => x.MainFileId,
                        principalTable: "TemplateFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_Templates_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "Solutions",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    PLangId = table.Column<int>(nullable: false),
                    AssessmentId = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastEditingIpAddress = table.Column<string>(maxLength: 2000, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    Note = table.Column<string>(maxLength: 10000, nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Solutions", x => new { x.UserId, x.ExerciseReleaseId, x.PLangId });
                    table.ForeignKey(
                        name: "FK_Solutions_SolutionAssessment_AssessmentId",
                        column: x => x.AssessmentId,
                        principalTable: "SolutionAssessment",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Solutions_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                    table.ForeignKey(
                        name: "FK_Solutions_ExerciseReleaseWithUserAsParticipations_UserId_ExerciseReleaseId",
                        columns: x => new { x.UserId, x.ExerciseReleaseId },
                        principalTable: "ExerciseReleaseWithUserAsParticipations",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithSingleSolutionAsTestResult",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    CompileTimeoutInMsUsed = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(maxLength: 160100, nullable: true),
                    RunnerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TestResultCode = table.Column<int>(nullable: true),
                    TestServerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TimeForCompiling = table.Column<int>(nullable: true),
                    TimeForUserProgram = table.Column<int>(nullable: true),
                    TimeoutInMsUsed = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithSingleSolutionAsTestResult", x => new { x.CustomTestId, x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithSingleSolutionAsTestResult_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithSingleSolutionAsTestResult_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    Content = table.Column<string>(maxLength: 70000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(maxLength: 2000, nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false),
                    TemplateFileId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionFiles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SolutionFiles_TemplateFiles_TemplateFileId",
                        column: x => x.TemplateFileId,
                        principalTable: "TemplateFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_SolutionFiles_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestWithSingleSolutionAsTestResult",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    CompileTimeoutInMsUsed = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(maxLength: 160100, nullable: true),
                    RunnerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TestResultCode = table.Column<int>(nullable: true),
                    TestServerVersion = table.Column<string>(maxLength: 2000, nullable: true),
                    TimeForCompiling = table.Column<int>(nullable: true),
                    TimeForUserProgram = table.Column<int>(nullable: true),
                    TimeoutInMsUsed = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithSingleSolutionAsTestResult", x => new { x.TestId, x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId });
                    table.ForeignKey(
                        name: "FK_TestWithSingleSolutionAsTestResult_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestWithSingleSolutionAsTestResult_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjects_UserId",
                table: "CustomProjects",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptions_CustomProjectId",
                table: "CustomProjectDescriptions",
                column: "CustomProjectId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptionWithFileAsAssetReferences_CustomProjectDescriptionId",
                table: "CustomProjectDescriptionWithFileAsAssetReferences",
                column: "CustomProjectDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectDescriptionWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomProjectDescriptionWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_CustomProjectId",
                table: "CustomProjectSolutions",
                column: "CustomProjectId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_MainFileId",
                table: "CustomProjectSolutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutions_PLangId",
                table: "CustomProjectSolutions",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectSolutionFiles_CustomProjectSolutionId",
                table: "CustomProjectSolutionFiles",
                column: "CustomProjectSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_CustomProjectId",
                table: "CustomProjectTests",
                column: "CustomProjectId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_TestSettingsId",
                table: "CustomProjectTests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTests_TestTypeId",
                table: "CustomProjectTests",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithFileAsAssetReferences_CustomProjectTestId",
                table: "CustomProjectTestWithFileAsAssetReferences",
                column: "CustomProjectTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomProjectTestWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithSolutionAsTestResults_CustomProjectSolutionId",
                table: "CustomProjectTestWithSolutionAsTestResults",
                column: "CustomProjectSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomProjectTestWithSolutionAsTestResults_CustomProjectTestId",
                table: "CustomProjectTestWithSolutionAsTestResults",
                column: "CustomProjectTestId");

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutions_MainFileId",
                table: "AfterSolutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "AfterSolutions",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" },
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutionFiles_AfterSolutionId",
                table: "AfterSolutionFiles",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_AfterSolutionFiles_TemplateFileId",
                table: "AfterSolutionFiles",
                column: "TemplateFileId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithAfterSolutionAsTestResults_AfterSolutionId",
                table: "CustomTestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithAfterSolutionAsTestResults_CustomTestId",
                table: "CustomTestWithAfterSolutionAsTestResults",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithAfterSolutionAsTestResults_AfterSolutionId",
                table: "TestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithAfterSolutionAsTestResults_TestId",
                table: "TestWithAfterSolutionAsTestResults",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_Templates_ExerciseId",
                table: "Templates",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_Templates_MainFileId",
                table: "Templates",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Templates_PLangId",
                table: "Templates",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithFileAsAssetReferences_CustomTestId",
                table: "CustomTestWithFileAsAssetReferences",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithFileAsAssetReferences_FileReferenceUserFileAssetId",
                table: "CustomTestWithFileAsAssetReferences",
                column: "FileReferenceUserFileAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_Exercises_UserGroupId",
                table: "Exercises",
                column: "UserGroupId");

            migrationBuilder.CreateIndex(
                name: "IX_Exercises_UserId",
                table: "Exercises",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptions_ExerciseId",
                table: "ExerciseDescriptions",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptionWithFileAsAssetReferences_ExerciseDescriptionId",
                table: "ExerciseDescriptionWithFileAsAssetReferences",
                column: "ExerciseDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptionWithFileAsAssetReferences_FileReferenceMarkdownAssetId",
                table: "ExerciseDescriptionWithFileAsAssetReferences",
                column: "FileReferenceMarkdownAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_MetaDatas_ExerciseId",
                table: "MetaDatas",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_MetaDatas_ExerciseId1",
                table: "MetaDatas",
                column: "ExerciseId1");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleases_ExerciseId",
                table: "ExerciseReleases",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleases_PLangId",
                table: "ExerciseReleases",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSingleSolutionAsTestResult_CustomTestId",
                table: "CustomTestWithSingleSolutionAsTestResult",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSingleSolutionAsTestResult_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "CustomTestWithSingleSolutionAsTestResult",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_ExerciseReleaseId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "ExerciseReleaseId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "LastEditedPLangId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_UserId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_AssessmentId",
                table: "Solutions",
                column: "AssessmentId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_MainFileId",
                table: "Solutions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_PLangId",
                table: "Solutions",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_UserId_ExerciseReleaseId",
                table: "Solutions",
                columns: new[] { "UserId", "ExerciseReleaseId" });

            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_TemplateFileId",
                table: "SolutionFiles",
                column: "TemplateFileId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_TestWithSingleSolutionAsTestResult_TestId",
                table: "TestWithSingleSolutionAsTestResult",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithSingleSolutionAsTestResult_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "TestWithSingleSolutionAsTestResult",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "Unique_Tag",
                table: "Tags",
                column: "DisplayName");

            migrationBuilder.CreateIndex(
                name: "IX_TagWithMetaDatas_MetaDataId",
                table: "TagWithMetaDatas",
                column: "MetaDataId");

            migrationBuilder.CreateIndex(
                name: "IX_TagWithMetaDatas_TagId",
                table: "TagWithMetaDatas",
                column: "TagId");

            migrationBuilder.CreateIndex(
                name: "IX_TemplateFiles_CodeTemplateId",
                table: "TemplateFiles",
                column: "CodeTemplateId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTest_TestTypeId",
                table: "CustomTest",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTest_UserId_ExerciseReleaseId",
                table: "CustomTest",
                columns: new[] { "UserId", "ExerciseReleaseId" });

            migrationBuilder.CreateIndex(
                name: "IX_DefaultCustomTestSettings_ExerciseId",
                table: "DefaultCustomTestSettings",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tests_ExerciseId",
                table: "Tests",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_Tests_TestSettingsId",
                table: "Tests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tests_TestTypeId",
                table: "Tests",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithFileAsAssetReferences_FileReferenceTestAssetId",
                table: "TestWithFileAsAssetReferences",
                column: "FileReferenceTestAssetId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithFileAsAssetReferences_TestId",
                table: "TestWithFileAsAssetReferences",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_AuthTokens_UserAuthToken",
                table: "AuthTokens",
                column: "UserAuthToken",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_AuthTokens_UserId",
                table: "AuthTokens",
                column: "UserId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_ExternalUsers_UserId",
                table: "ExternalUsers",
                column: "UserId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_GroupRoles_GroupRolePermissionId",
                table: "GroupRoles",
                column: "GroupRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_CodeEditorSettingsId",
                table: "UserSettingses",
                column: "CodeEditorSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_LangId",
                table: "UserSettingses",
                column: "LangId");

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_UserId",
                table: "UserSettingses",
                column: "UserId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemRoles_SystemRolePermissionId",
                table: "SystemRoles",
                column: "SystemRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupCreatorGroupRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultUserGroupId",
                table: "SystemSettings",
                column: "DefaultUserGroupId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Users_SystemRoleId",
                table: "Users",
                column: "SystemRoleId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_GroupRoleId",
                table: "UserWithUserGroups",
                column: "GroupRoleId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_UserGroupId",
                table: "UserWithUserGroups",
                column: "UserGroupId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_UserId",
                table: "UserWithUserGroups",
                column: "UserId");

            migrationBuilder.AddForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjectSolutionFiles_MainFileId",
                table: "CustomProjectSolutions",
                column: "MainFileId",
                principalTable: "CustomProjectSolutionFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);

            migrationBuilder.AddForeignKey(
                name: "FK_AfterSolutionFiles_AfterSolutions_AfterSolutionId",
                table: "AfterSolutionFiles",
                column: "AfterSolutionId",
                principalTable: "AfterSolutions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_AfterSolutionFiles_TemplateFiles_TemplateFileId",
                table: "AfterSolutionFiles",
                column: "TemplateFileId",
                principalTable: "TemplateFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_CustomTestWithAfterSolutionAsTestResults_AfterSolutions_AfterSolutionId",
                table: "CustomTestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId",
                principalTable: "AfterSolutions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TestWithAfterSolutionAsTestResults_AfterSolutions_AfterSolutionId",
                table: "TestWithAfterSolutionAsTestResults",
                column: "AfterSolutionId",
                principalTable: "AfterSolutions",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_AfterSolutions_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "AfterSolutions",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" },
                principalTable: "Solutions",
                principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_TemplateFiles_Templates_CodeTemplateId",
                table: "TemplateFiles",
                column: "CodeTemplateId",
                principalTable: "Templates",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_SolutionFiles_MainFileId",
                table: "Solutions",
                column: "MainFileId",
                principalTable: "SolutionFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjects_Users_UserId",
                table: "CustomProjects");

            migrationBuilder.DropForeignKey(
                name: "FK_Exercises_Users_UserId",
                table: "Exercises");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_Users_UserId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjects_CustomProjectId",
                table: "CustomProjectSolutions");

            migrationBuilder.DropForeignKey(
                name: "FK_CustomProjectSolutions_CustomProjectSolutionFiles_MainFileId",
                table: "CustomProjectSolutions");

            migrationBuilder.DropForeignKey(
                name: "FK_Templates_PLangs_PLangId",
                table: "Templates");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_AfterSolutions_AfterSolutionFiles_MainFileId",
                table: "AfterSolutions");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionFiles_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionFiles");

            migrationBuilder.DropForeignKey(
                name: "FK_Templates_TemplateFiles_MainFileId",
                table: "Templates");

            migrationBuilder.DropTable(
                name: "AwaitDummies");

            migrationBuilder.DropTable(
                name: "CustomProjectDescriptionWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "CustomProjectTestAssets");

            migrationBuilder.DropTable(
                name: "CustomProjectTestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "CustomProjectTestWithSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "CustomTestWithAfterSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "TestWithAfterSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "CustomTestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "ExerciseDescriptionWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "CustomTestWithSingleSolutionAsTestResult");

            migrationBuilder.DropTable(
                name: "TestWithSingleSolutionAsTestResult");

            migrationBuilder.DropTable(
                name: "TagWithMetaDatas");

            migrationBuilder.DropTable(
                name: "DefaultCustomTestSettings");

            migrationBuilder.DropTable(
                name: "TestWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "AuthTokens");

            migrationBuilder.DropTable(
                name: "ExternalUsers");

            migrationBuilder.DropTable(
                name: "UserSettingses");

            migrationBuilder.DropTable(
                name: "SystemSettings");

            migrationBuilder.DropTable(
                name: "UserWithUserGroups");

            migrationBuilder.DropTable(
                name: "CustomProjectDescriptions");

            migrationBuilder.DropTable(
                name: "CustomProjectTests");

            migrationBuilder.DropTable(
                name: "FileReferenceUserFileAssets");

            migrationBuilder.DropTable(
                name: "ExerciseDescriptions");

            migrationBuilder.DropTable(
                name: "FileReferenceMarkdownAssets");

            migrationBuilder.DropTable(
                name: "CustomTest");

            migrationBuilder.DropTable(
                name: "MetaDatas");

            migrationBuilder.DropTable(
                name: "Tags");

            migrationBuilder.DropTable(
                name: "FileReferenceTestAssets");

            migrationBuilder.DropTable(
                name: "Tests");

            migrationBuilder.DropTable(
                name: "CodeEditorSettings");

            migrationBuilder.DropTable(
                name: "Langs");

            migrationBuilder.DropTable(
                name: "GroupRoles");

            migrationBuilder.DropTable(
                name: "TestCaseSettingses");

            migrationBuilder.DropTable(
                name: "TestTypes");

            migrationBuilder.DropTable(
                name: "GroupRolePermissions");

            migrationBuilder.DropTable(
                name: "Users");

            migrationBuilder.DropTable(
                name: "SystemRoles");

            migrationBuilder.DropTable(
                name: "SystemRolePermissions");

            migrationBuilder.DropTable(
                name: "CustomProjects");

            migrationBuilder.DropTable(
                name: "CustomProjectSolutionFiles");

            migrationBuilder.DropTable(
                name: "CustomProjectSolutions");

            migrationBuilder.DropTable(
                name: "PLangs");

            migrationBuilder.DropTable(
                name: "AfterSolutionFiles");

            migrationBuilder.DropTable(
                name: "AfterSolutions");

            migrationBuilder.DropTable(
                name: "Solutions");

            migrationBuilder.DropTable(
                name: "SolutionAssessment");

            migrationBuilder.DropTable(
                name: "SolutionFiles");

            migrationBuilder.DropTable(
                name: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropTable(
                name: "ExerciseReleases");

            migrationBuilder.DropTable(
                name: "TemplateFiles");

            migrationBuilder.DropTable(
                name: "Templates");

            migrationBuilder.DropTable(
                name: "Exercises");

            migrationBuilder.DropTable(
                name: "UserGroups");
        }
    }
}
