﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace ClientServer.Migrations
{
    public partial class addFakeFksToOtherSides : Migration
    {
        
        //actually we want to drop the foreign key constraint to on delete no action
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "CustomProjectTestSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn),
                    CompileTimeoutInMs = table.Column<int>(nullable: false),
                    CompilerOptions = table.Column<string>(maxLength: 2000, nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomProjectTestId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    MemoryLimitInKb = table.Column<int>(nullable: false),
                    TimeoutInMs = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomProjectTestSettings", x => x.Id);
                });

            migrationBuilder.AddColumn<int>(
                name: "SystemRoleId",
                table: "SystemRolePermissions",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "UserSettingId",
                table: "CodeEditorSettings",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "GroupRoleId",
                table: "GroupRolePermissions",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "TestId",
                table: "TestCaseSettingses",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "ExerciseReleaseId",
                table: "SolutionAssessment",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "PLangId",
                table: "SolutionAssessment",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "UserId",
                table: "SolutionAssessment",
                nullable: false,
                defaultValue: 0);
            
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "SystemRoleId",
                table: "SystemRolePermissions");

            migrationBuilder.DropColumn(
                name: "UserSettingId",
                table: "CodeEditorSettings");

            migrationBuilder.DropColumn(
                name: "GroupRoleId",
                table: "GroupRolePermissions");

            migrationBuilder.DropColumn(
                name: "TestId",
                table: "TestCaseSettingses");

            migrationBuilder.DropColumn(
                name: "ExerciseReleaseId",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "PLangId",
                table: "SolutionAssessment");

            migrationBuilder.DropColumn(
                name: "UserId",
                table: "SolutionAssessment");

            migrationBuilder.DropTable(
                name: "CustomProjectTestSettings");
        }
    }
}
